/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mnenhy.
 *
 * The Initial Developer of the Original Code is Karsten Duesterloh <mnenhy@tprac.de>.
 *
 * Portions created by the Initial Developer are Copyright (C) 2002-2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Karsten Duesterloh <mnenhy@tprac.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// |
// |  constants
// |

// debug
const gksChroManDebugPref = "extensions.mnenhy.debug.chroman";
// element ids
const gksChroManTree   = "mnenhyChroManTree";
const gksChroManCont   = "mnenhyChroManTreeChildren";
const gkrsBaseBC       = {ksBCGodMode  : "bcIsGodMode",
                          ksBCSelection: "bcHaveSelection",
                          ksBCDirty    : "bcIsDirty",
                          ksBCProfile  : "bcIsProfile",
                          ksBCStatusCol: "bcHaveStatusCol",
                          ksBCValueCol : "bcHaveValueCol",
                          ksBCLocCol   : "bcHaveLocCol",
                          ksBCJarCol   : "bcHaveJarCol"    };
const gkrsButtonBC     = {ksBCNoJar    : "bcNoJar",
                          ksBCNoStatus : "bcNoStatus",
                          ksBCNoMove   : "bcNoMove",
                          ksBCNoValue  : "bcNoValue",
                          ksBCNoReset  : "bcNoReset"       };
// tree columns
const gksPackName      = "mnenhyPackName";
const gksPackValue     = "mnenhyPackValue";
const gksPackState     = "mnenhyPackStatus";
const gksPackLoc       = "mnenhyPackLoc";
const gksPackJar       = "mnenhyPackJar";
const gksPackRemove    = "mnenhyPackRemove";  // pseudo column (button)
const gkColPack        = 0;
const gkColValue       = 1;
const gkColState       = 2;
const gkColLoc         = 3;
const gkColJar         = 4;

const gksTreeCont      = "treechildren";
const gksTreeItem      = "treeitem";
const gksTreeRow       = "treerow";
const gksTreeCell      = "treecell";
const gksTreeCellImage = "image";

const gksAttrDivider   = "_";
const gksAttrOldSuffix = gksAttrDivider + "bak";
const gksAttrFlags     = "mnenhyFlags";
const gksAttrFlagsOld  = gksAttrFlags + gksAttrOldSuffix;
const gksAttrID        = "id";
const gksAttrCont      = "container";
const gksAttrLabel     = "label";
const gksAttrProp      = "properties";
const gksAttrDisabled  = "disabled";
const gksAttrElem      = "element";
const gksAttrAttr      = "attribute";
const gksAttrValue     = "val";
const gksAttrOpen      = "open";

const gkxMozillaNS     = new RegExp("^" + goMnenhy.uninstall.gksMozillaNamespace);
const gksPropPack      = "package";

const gksBaseSplitter  = ":";
//const gksBase          = "urn"
//const gksBaseCont      = "mozilla";
const gksBaseRoot      = "root";
const gksBasePack      = "package";
const gksBasePacks     = "packages";
const gksBaseProp      = "property";
const gksBaseSkin      = "skin";
const gksBaseLoc       = "locale";

const gkoProperties    = goMnenhy.InitStringBundle("chrome://mnenhy/locale/mnenhy-chroman.properties");
const gksRootTitle     = goMnenhy.GetString("MnDialog_ChroMan_RootTitle",     gkoProperties);
const gksPackLabel     = goMnenhy.GetString("MnDialog_ChroMan_PackLabel",     gkoProperties);
const gksPropLabel     = goMnenhy.GetString("MnDialog_ChroMan_PropLabel",     gkoProperties);
const gksSkinLabel     = goMnenhy.GetString("MnDialog_ChroMan_SkinLabel",     gkoProperties);
const gksLocLabel      = goMnenhy.GetString("MnDialog_ChroMan_LocLabel",      gkoProperties);
const gksStateActive   = goMnenhy.GetString("MnDialog_ChroMan_StateActive",   gkoProperties);
const gksStateInactive = goMnenhy.GetString("MnDialog_ChroMan_StateInactive", gkoProperties);
const gksStateDeleted  = goMnenhy.GetString("MnDialog_ChroMan_StateDeleted",  gkoProperties);
const gksLocationApp   = goMnenhy.GetString("MnDialog_ChroMan_LocationApp",   gkoProperties);
const gksLocationUser  = goMnenhy.GetString("MnDialog_ChroMan_LocationUser",  gkoProperties);
const gksHelpURL       = goMnenhy.GetString("MnDialog_ChroMan_HelpURL",       gkoProperties);
const gksExitDialogOK  = goMnenhy.GetString("MnDialog_ChroMan_ExitOK",        gkoProperties);
const gksExitCancel    = goMnenhy.GetString("MnDialog_ChroMan_ExitCancel",    gkoProperties);

// state flags based upon properties
const gksFlagPropBase  = "mnenhyChroMan"
// read flags
// - package disabled
const gksFlagDisRDF    = "disabled";  // rdf property
const gksFlagDisTest   = "true";      // rdf value
const gksFlagDisCSS    = "inactive";  // css property and flag
// - entry resides in profile chrome.rdf
const gksFlagUserRDF   = "locType";
const gksFlagUserTest  = "profile";
const gksFlagUserCSS   = "profile";   // flag
// - entry data is stored in jar
const gksFlagJarRDF    = "baseURL";
const gksFlagJarScheme = "jar:";
const gkxFlagJarTest   = new RegExp("^" + gksFlagJarScheme);
const gkxFlagJarSuffix = /\.jar$/;
const gksFlagJarMidfix = ".jar!";
const gksFlagJarResRel = "resource:/chrome/";
const gksFlagJarResAbs = "resource:///chrome/";
const gkxFlagJarPack   = /([^\/]+)(.*)/;
const gkxFlagJarType   = /^\/[^\/]+/;
const gkxFlagJarTypeCh = /!\/([^\/]+)/;
const gksFlagJarCSS    = "local";     // flag

// internal flags
const gksFlagDelCSS    = "deleted";   // flag for packages marked for deletion
const gksFlagHidePack  = "hidepack";  // flag: hide package styles (eg dirty icon)
const gksFlagHideState = "hidestate"; // flag: hide status styles (incl. value)
const gksFlagHideLoc   = "hideloc";   // flag: hide location styles (incl. value)
const gksFlagNoIconLoc = "noiconloc"; // flag: hide location icon (but show value)
const gksFlagHideJar   = "hidejar";   // flag: hide ja styles (incl. value)
const gksFlagLabel     = "label";     // flag: label text ("name") of this chrome entry
const gksFlagValue     = "value";     // flag: value text of this chrome entry
const gksFlagValueCSS  = "link";      // flag
const gksFlagDirty     = "dirty";     // dirty flag

const gksFlagBase      = "FlagBase";
const gksFlagYes       = "FlagYes";
const gksCheckmarkBase = "CheckmarkBase";
const gksCheckmarkYes  = "CheckmarkYes";
const gksDiamondBase   = "DiamondBase";
const gksDiamondYes    = "DiamondYes";


// |
// |  vars
// |
var goChroManTree      = null;  // will be set to getElementById("mnenhyChroManTree")
var goChroManCont      = null;  // will be set to getElementById("mnenhyChroManTreeChildren")
var goChroManPopup     = null;  // will get certain elements of the "mnenhyChroManContext" popup
var goChroManRDF       = null;  // will be set to {app: <chrome.rdf>, user: <chrome.rdf>};
var gbChroManDebugDump = null;  // will be set to pref extensions.mnenhy.debug.chroman
var gfSort             = null;  // will be set to goMnenhy.CSort, but with this-context

// |
// |  file handling
// |

// Get chrome information from URI:
//    location:     interpret file:// as profile and resource:// as application
//    jar:          check if jar URI
//    package type: check respective part of corresponding jar URI
//
// IN:  string asURI
// OUT: {Boolean isProfile, Boolean isJar, string sType}
function ChromeURI2Info(asURI)
{
  var oRet = {isProfile: null, isJar: null, sType: null};
  if (asURI)
  { // create URI from string
    var oURI = goMnenhy.m_koIOService.newURI(asURI, null, null);
    // check jar
    oRet.isJar = oURI.schemeIs(goMnenhy.ksProtocolJar);
    if (oRet.isJar)
      oURI = goMnenhy.m_koIOService.newURI(oURI.path, null, null);
    // check profile
    oRet.isProfile = !oURI.schemeIs(goMnenhy.ksProtocolRes);
    // check type
    const ksCheckURI   = ChromeInfo2URI(asURI, false, true);
    const krsCheckType = ksCheckURI.match(gkxFlagJarTypeCh);
    if (krsCheckType && ("1" in krsCheckType))
      oRet.sType = krsCheckType[1];
  }
  return oRet;
}


// set location and jar status
// returns string with (possibly unchanged) URI
//
// jar:resource:/chrome/mnenhy.jar!/content/mnenhy/...
//  |  \_______________/  |   \__/  \_____/\_________/
//  |          |          |     |    sType sPathSuffix
//  |          |          |     |  \_________________/
//  |          |          |     |          |
//  |     sChromePath     |     |      sEntryPath
// sJarPrefix          sPackage `sJarSuffix
//
function ChromeInfo2URI(asURI, abProfile, abJar, asType)
{
  var sRet = asURI;
  if (sRet)
  {
    const ksUserChrome = goMnenhy.GetProtocolHandler().getURLSpecFromFile(goMnenhy.m_koChromeDirUser);

    var sJarPrefix  = abJar     ? gksFlagJarScheme : "";
    var sJarSuffix  = abJar     ? gksFlagJarMidfix : "";
    var sChromePath = abProfile ? ksUserChrome     : gksFlagJarResRel;
    var sPackage    = "";
    var sEntryPath  = "";

    // create URI from string
    var oURI = goMnenhy.m_koIOService.newURI(sRet, null, null);
    sRet = oURI.spec;

    // do we have a jar?
    if (oURI instanceof Components.interfaces.nsIJARURI)
    { // get the jar URI
      sEntryPath = "/" + oURI.JAREntry;// + "/";
      oURI = oURI.JARFile;
      sRet = oURI.spec.replace(gkxFlagJarSuffix, "");
    }

    if (oURI.schemeIs(goMnenhy.ksProtocolRes))
    { // delete the chrome path
      sRet = sRet.replace(gksFlagJarResAbs, "")
    }
    else if (oURI.schemeIs(goMnenhy.ksProtocolFile))
    { // delete the profile path
      sRet = sRet.replace(ksUserChrome, "")
    }
    else
      return null;  // huh! dunno! giving up ...

    // either have 'pack' or 'pack/entry/path/'
    var r = gkxFlagJarPack.exec(sRet)
    sPackage = r[1];
    if (!sEntryPath)
      sEntryPath = r[2];

    // replace the package type
    if (sEntryPath && asType)
      sEntryPath = sEntryPath.replace(gkxFlagJarType, "/" + asType);

    // build the new URI
    sRet = sJarPrefix + sChromePath + sPackage + sJarSuffix + sEntryPath;
  }
  return sRet;
}


// extract a single package to a local location
function ExtractSinglePackage(asSourceURL, asTargetURL)
{
  debugdump("Mnenhy::ExtractSinglePackage("+asSourceURL+", "+asTargetURL+")+\n");
  const koSourceURI = goMnenhy.m_koIOService.newURI(asSourceURL, null, null);
  if (koSourceURI instanceof Components.interfaces.nsIJARURI)
  { // get the jar URI
    var oJarURI   = koSourceURI.JARFile;  // nsIURI
    var sJarEntry = koSourceURI.JAREntry;
    if (sJarEntry[sJarEntry.length - 1] == "/")
      sJarEntry += "*"; // string
    if (oJarURI instanceof Components.interfaces.nsIFileURL)
    { // and now for something completely different ... the target directory!
      // skip an eventual entry path in the target URL by changing it into a
      // JAR URI and taking just that
      const koLocJar = ChromeURI2Info(asTargetURL);
      const ksTargetJAR = ChromeInfo2URI(asTargetURL, koLocJar.isProfile, true);
      const koTargetJAR = goMnenhy.m_koIOService.newURI(ksTargetJAR, null, null);
      if (koTargetJAR instanceof Components.interfaces.nsIJARURI)
      {
        asTargetURL = koTargetJAR.JARFile.spec.replace(gkxFlagJarSuffix, "");
        asTargetURL = ChromeInfo2URI(asTargetURL, koLocJar.isProfile, false);
        const koTargetURI = goMnenhy.m_koIOService.newURI(asTargetURL, null, null);
        if (koTargetURI instanceof Components.interfaces.nsIFileURL)
        { // just do it!
          debugdump("Mnenhy::ExtractSinglePackage:jar="+oJarURI.file.path+", entry="+sJarEntry+", target="+koTargetURI.file.path+"\n");
          goMnenhy.ExtractZip(oJarURI.file, koTargetURI.file, sJarEntry, false, window);
        } // have file target
      }
    } // have jar file
  } // have jar URI
  debugdump("Mnenhy::ExtractSinglePackage-\n");
}


// delete the local files of a single package at the current location
function PurgeSinglePackage(asIgnored, asTargetURL)
{ // get the target directory
  debugdump("Mnenhy::PurgeSinglePackage("+asTargetURL+")+\n");
  const koLocJar = ChromeURI2Info(asTargetURL);
  asTargetURL = ChromeInfo2URI(asTargetURL, koLocJar.isProfile, false);
  const koTargetURI = goMnenhy.m_koIOService.newURI(asTargetURL, null, null);
  if (koTargetURI instanceof Components.interfaces.nsIFileURL)
  { // just do it!
    if (koTargetURI.file.path)
    { // don't kill our own dumb self. BTDT :(
      debugdump("Mnenhy::PurgeSinglePackage: "+koTargetURI.file.path+"\n");
      goMnenhy.DeleteFile(koTargetURI.file, "");
    }
  } // have file target
  debugdump("Mnenhy::PurgeSinglePackage-\n");
}


// get current and old value of the selected treeitem
// and call afURLCallback with those
// (if no old value is given, it is assumed to be equal to the current)
function ProcessSinglePackage(afURLCallback)
{
  const koTreeItem = GetTreeItemAtRow();
  if (koTreeItem)
  {
    var oItem = GetBaseURLTreeItem(koTreeItem);
    if (oItem)
    { // get the URIs
      const koFlags    = GetFlags(oItem);
      const ksValue    = koFlags[gksFlagValue];
      const koFlagsBak = eval(GetFlags(oItem, true, true)) || koFlags;
      const ksValueBak = koFlagsBak[gksFlagValue];
      afURLCallback(ksValueBak, ksValue);
    } // have baseURL
  } // have package
}


// extract the jar (if any) of the selected treeitem
// into the current local directory
function ExtractPackage()
{
  goMnenhy.SetWaitCursor(window);
  ProcessSinglePackage(ExtractSinglePackage);
  goMnenhy.UnsetWaitCursor(window);
}


// delete the local files of the package at the current location
function PurgePackage()
{
  goMnenhy.SetWaitCursor(window);
  ProcessSinglePackage(PurgeSinglePackage);
  goMnenhy.UnsetWaitCursor(window);
}


// clean the chrome registry
function PurifyChrome()
{
  goMnenhy.SetWaitCursor(window);
  goMnenhy.uninstall.PurgeChromeRegistry();
  goMnenhy.UnsetWaitCursor(window);
}


function ChroManHelp()
{
  opener.window.open(gksHelpURL, "_new");
}


// get the treeitem for the given aiRow
// for aiRow < 0, get treeitem at currentIndex
function GetTreeItemAtRow(aiRow)
{
  if ((!aiRow) || (aiRow < 0))
    aiRow = goChroManTree.currentIndex;
  if (aiRow < 0)
    return null;
  var oTreeItem = goChroManTree.contentView.getItemAtIndex(aiRow);
  return oTreeItem;
}


// get the asFlag treeitem corresponding to aoTreeItem
// default asFlag is gksFlagJarRDF
// if abIsAppOverride is not |null|, it will be used instead of the aoTreeItem's location
function GetBaseURLTreeItem(aoTreeItem, asFlag, abIsAppOverride)
{ // get the treeitem location from the backup
  var bIsApp = abIsAppOverride;
  if (bIsApp == null) // catches null and undefined, but not true or false
  {
    var koProfile = {};
    koProfile[gksFlagUserCSS] = true;
    bIsApp = !TestFlags(aoTreeItem, koProfile, true);
  }
  // find this package's asFlag property
  if (!asFlag)
    asFlag = gksFlagJarRDF;
  var rsID = aoTreeItem.getAttribute(gksAttrID).split(gksBaseSplitter);
  rsID.push(bIsApp + gksAttrDivider + asFlag);
  return document.getElementById(goChroManRDF.app.CreateURN(rsID, true));
}


// Set the asAttr attribute of the given broadcaster ID asID to asValue.
// (asAttr defaults to 'value')
function SetBroadcasterValue(asID, asValue, asAttr)
{
  if (asID)
  {
    if (!asAttr)
      asAttr = gksAttrValue;
    const koBC = document.getElementById(asID);
    if (koBC)
      koBC.setAttribute(asAttr, asValue)
  }
}
// Get the asAttr attribute of the given broadcaster ID asID
// (asAttr defaults to 'value')
function GetBroadcasterValue(asID, asAttr)
{
  var sValue = "";
  if (asID)
  {
    if (!asAttr)
      asAttr = gksAttrValue;
    const koBC = document.getElementById(asID);
    if (koBC)
      sValue = koBC.getAttribute(asAttr);
  }
  return sValue;
}


// Compute the asDisabled attribute value for the broadcaster aoThis
// by checking all the 'attribute' attribute values of the broadcasters it observes.
// The observed values will be |and|ed or |or|ed, depending on abOr,
// the result will be negated if abNoNegate is |false|.
// (abOr defaults to |true|, asDisabled defaults to 'disabled')
function SetBroadcasterDisabled(aoThis, abNoNegate, abOr, asDisabled)
{
//dump(",-- "+aoThis.id+"\n")
  abOr = !!abOr;
  if (!asDisabled)
    asDisabled = gksAttrDisabled;
  const koChildren = aoThis.childNodes;
  const klSize     = koChildren.length;
  var bVal = !!klSize && !abOr;
  for (var i = 0; i < klSize; ++i)
  {
    const ksBC  = koChildren[i].getAttribute(gksAttrElem);
    const koBC  = document.getElementById(ksBC);
    const ksVal = koChildren[i].getAttribute(gksAttrAttr);
    if (koBC)
    {
//dump("| "+ksBC+": "+ksVal+"="+koBC.getAttribute(ksVal)+"\n")
      const kbIsTrue = (koBC.getAttribute(ksVal) == "true");
      if (abOr)
      {
        bVal |= kbIsTrue;
        if (bVal)
          break;
      }
      else
      {
        bVal &= kbIsTrue;
        if (!bVal)
          break;
      }
    }
  }
  if (!abNoNegate)
    bVal ^= true;
  aoThis.setAttribute(asDisabled, Boolean(bVal));
//dump("`-- "+aoThis.getAttribute(asDisabled)+"\n")
}
// Get the Boolean value of the broadcasters' asID attribute asDisabled.
// Will return |true| in case of error
// (asDisabled defaults to 'disabled')
function GetBroadcasterDisabled(asID, asDisabled)
{
  var bValue = true;
  if (asID)
  {
    if (!asDisabled)
      asDisabled = gksAttrDisabled;
    bValue = (GetBroadcasterValue(asID, asDisabled) == "true");
  }
  return bValue;
}


// update the tree state broadcasters
function CheckTreeSelect(aoEventIgnored)
{
  var oFlags = {};
  const koTreeItem = GetTreeItemAtRow();
  // we only get here if we've selected an item
  SetBroadcasterValue(gkrsBaseBC.ksBCSelection, true);
  // do we have changes?
  SetBroadcasterValue(gkrsBaseBC.ksBCDirty, IsFlagsDirty(koTreeItem));
  // profile?
  oFlags[gksFlagUserCSS] = true;
  SetBroadcasterValue(gkrsBaseBC.ksBCProfile, TestFlags(koTreeItem, oFlags));
  // which columns do we have?
  oFlags = {};
  oFlags[gksFlagHideState] = true;
  SetBroadcasterValue(gkrsBaseBC.ksBCStatusCol, !TestFlags(koTreeItem, oFlags));
  oFlags = {};
  oFlags[gksFlagHideJar] = true;
  SetBroadcasterValue(gkrsBaseBC.ksBCJarCol, !TestFlags(koTreeItem, oFlags));
  oFlags = {};
  oFlags[gksFlagHideLoc]   = true;
  var bHidden = TestFlags(koTreeItem, oFlags);
  oFlags = {};
  oFlags[gksFlagNoIconLoc] = true;
  bHidden |= TestFlags(koTreeItem, oFlags);
  SetBroadcasterValue(gkrsBaseBC.ksBCLocCol, !bHidden);
  oFlags = GetFlags(koTreeItem);
  bHidden = !(gksFlagValue in oFlags);
  SetBroadcasterValue(gkrsBaseBC.ksBCValueCol, !bHidden);
}


// get left clicks on tree images
function CheckTreeClick(aoEvent)
{
  if (!aoEvent.button)
  { // where did the left button hit?
    var oRow = {}, oColID = {}, oChildElt = {};
    goChroManTree.treeBoxObject.getCellAt(aoEvent.clientX, aoEvent.clientY, oRow, oColID, oChildElt);
    var sColID = oColID.value;
    // as of Mozilla 1.8a, oColID.value has changed from string to nsITreeColumn
    if (typeof(sColID) != "string")
      sColID = sColID.id;
    if (oChildElt.value == gksTreeCellImage)
    { // we're only interested in image clicks
      switch (sColID)
      { // check broadcasters for permission
        case gksPackState:  // state toggle
          if (!GetBroadcasterDisabled(gkrsButtonBC.ksBCNoStatus))
            ProcessToggleHit(sColID, oRow.value);
          break;
        case gksPackLoc:    // location toggle
          if (!GetBroadcasterDisabled(gkrsButtonBC.ksBCNoMove))
            ProcessToggleHit(sColID, oRow.value);
          break;
        case gksPackJar:    // jar toggle
          if (!GetBroadcasterDisabled(gkrsBaseBC.ksBCSelection, gksAttrValue))
          { // clicking cycler columns does not select the line, so we have to do that here
            goChroManTree.view.selection.select(oRow.value);
            CheckTreeSelect();
          }
          if (!GetBroadcasterDisabled(gkrsButtonBC.ksBCNoJar))
            ProcessToggleHit(sColID, oRow.value);
          break;
        case gksPackName:   // dirty flag
          if (!GetBroadcasterDisabled(gkrsButtonBC.ksBCNoReset))
            ProcessToggleHit(sColID, oRow.value);
          break;
      } // switch column
    } // image clicked
    else if ((aoEvent.detail == 2) && (sColID == gksPackValue))
    { // double click on value column jumps to the id given there
      if (!GetBroadcasterDisabled(gkrsButtonBC.ksBCNoValue))
        ProcessToggleHit(gksPackValue, oRow.value);
    }
  } // left button
}


// get treeitem by aiRow or current selection
function ProcessToggleHit(asColID, aiRow)
{
  var oTreeItem = GetTreeItemAtRow(aiRow);
  if (oTreeItem)
    ProcessToggleHitItem(oTreeItem, asColID)
}


// perform action upon treeitem depending on column
function ProcessToggleHitItem(aoTreeItem, asColID)
{
  switch (asColID)
  {
    case gksPackName:   // dirty flag
      ResetFlags(aoTreeItem);
      break;
    case gksPackState:  // state toggle
      ToggleState(aoTreeItem);
      break;
    case gksPackLoc:    // location toggle
      ToggleLocation(aoTreeItem);
      break;
    case gksPackJar:    // jar toggle
      ToggleJar(aoTreeItem);
      break;
    case gksPackRemove: // remove toggle
      ToggleRemove(aoTreeItem);
      break;
    case gksPackValue:  // value jump
      JumpToURN(aoTreeItem);
      break;
  }
  CheckTreeSelect();  // update broadcasters
}


// double click on value column jumps to the id given there
// if no id there, do default handling (open/close)
// (we don't have to check that, because ids are only at leafs)
function JumpToURN(aoTreeItem)
{
  const koFlags = GetFlags(aoTreeItem);
  if (gksFlagValue in koFlags)
  {
    const ksURN = koFlags[gksFlagValue];
    if (ksURN)
    {
      const koTarget = document.getElementById(ksURN);
      if (koTarget)
      { // ensure that all parents are open
        // otherwise getIndexOfItem will fail :(
        for (var oPa = koTarget.parentNode; oPa; oPa = oPa.parentNode)
        {
          if (oPa.nodeName == gksTreeItem)
            oPa.setAttribute(gksAttrOpen, "true");  // open it!
        }
        // the tree functions want an index
        var kiIndex = goChroManTree.contentView.getIndexOfItem(koTarget);
        if (kiIndex > -1)
        {
          goChroManTree.view.selection.select(kiIndex);
          goChroManTree.treeBoxObject.ensureRowIsVisible(kiIndex);
        }
      }
    }
  }
}


// reset the changes made to this aoTreeItem
function ResetFlags(aoTreeItem)
{
  const ksFlagsBak = GetFlags(aoTreeItem, true, true);
  if (ksFlagsBak)
  { // we have something to do; get the differences
    // if this is a property, we need the corresponding package treeitem
    const koFlags    = GetFlags(aoTreeItem);
    const koFlagsBak = GetFlagsObj(ksFlagsBak);
    var   oItem  = aoTreeItem;
    var   oFlags = {};
    var   rsID   = oItem.getAttribute(gksAttrID).split(gksBaseSplitter);
    const ksProp = rsID.pop();
    const kiHash = ksProp.search(gksAttrDivider);
    if (kiHash < 0)
    { // no property: get the differences
      oFlags = DifferFlags(koFlags, koFlagsBak, true);
    }
    else
    { // property: get the parent package item, set pseudo flag
      oItem = document.getElementById(goChroManRDF.app.CreateURN(rsID, true)); // true is important!
      const ksPropName = ksProp.substr(kiHash + 1);  // pseudo flag, eg. gksFlagDisRDF
      if (ksPropName == gksFlagJarRDF)
      { // differ between jar and/or location changes
        var oURIBak = goMnenhy.m_koIOService.newURI(koFlagsBak[gksFlagValue], null, null);
        var oURI    = goMnenhy.m_koIOService.newURI(koFlags   [gksFlagValue], null, null);
        if (oURI.schemeIs(goMnenhy.ksProtocolJar) ^ oURIBak.schemeIs(goMnenhy.ksProtocolJar))
        { // jar status has changed
          oFlags[gksFlagJarCSS] = true;
        }
        // remove jar and test for location change
        oURIBak = goMnenhy.m_koIOService.newURI(oURIBak.spec.replace(gkxFlagJarTest, ""), null, null);
        oURI    = goMnenhy.m_koIOService.newURI(oURI   .spec.replace(gkxFlagJarTest, ""), null, null);
        if (!oURI.schemeIs(oURIBak.scheme))
        { // location has changed
          oFlags[gksFlagUserCSS] = true;
        }
      }
      else
        oFlags[ksPropName] = true;
    }

    // process the differences
    for (var sFlag in oFlags)
    {
      switch(sFlag)
      {
        case gksFlagDisRDF:
        case gksFlagDisCSS:
          ProcessToggleHitItem(oItem, gksPackState);
          break;
        case gksFlagUserCSS:
          ProcessToggleHitItem(oItem, gksPackLoc);
          break;
        case gksFlagJarCSS:
          ProcessToggleHitItem(oItem, gksPackJar);
          break;
        case gksFlagDelCSS:
          ProcessToggleHitItem(oItem, gksPackRemove);
          break;
      } // switch toggle
    } // for all flags
  } // if dirty
}


// toggle the asFlag of the aoTreeItem, if the flag asHidden is not set
// we will keep a copy of the original value in a "backup attribute"
function ToggleFlag(aoTreeItem, asFlag, asHidden)
{
  var oFlags    = GetFlags(aoTreeItem);
  if (!(asHidden in oFlags))
  {
    if (asFlag in oFlags)
    { // kill me!
      delete oFlags[asFlag];
    }
    else
    { // wanna have!
      oFlags[asFlag] = true;
    }
    SetChromeTreeItemStyles(aoTreeItem, oFlags);
  }
}


// toggle remove flag
function ToggleRemove(aoTreeItem)
{ // check visibility
  var oVisible = {};
  oVisible[gksFlagHideState] = true;
  if (!TestFlags(aoTreeItem, oVisible))
  { // visible!
    ToggleFlag(aoTreeItem, gksFlagDelCSS);
  }
}


// propagate the toggled jar of a treeitem down to the 'baseURL' property
function ToggleJar(aoTreeItem)
{ // check visibility
  var oVisible = {};
  oVisible[gksFlagHideJar] = true;
  if (!TestFlags(aoTreeItem, oVisible))
  { // visible!
    ToggleFlag(aoTreeItem, gksFlagJarCSS,  gksFlagHideJar);
    var oItem = GetBaseURLTreeItem(aoTreeItem);
    if (oItem)
    { // get the value column cell
      var   sBaseURL = GetFlags(oItem)[gksFlagValue];
      const koLocJar = ChromeURI2Info(sBaseURL);
      sBaseURL = ChromeInfo2URI(sBaseURL, koLocJar.isProfile, !koLocJar.isJar);
      // update tree
      var oFlags = {};
      oFlags[gksFlagValue] = sBaseURL;
      AddChromeTreeItemStyles(oItem, oFlags)
    }
    else
    { // no 'baseURL'
      dump("Mnenhy::no property 'baseURL' for "+aoTreeItem.getAttribute(gksAttrID)+"\n")
    }
  } // visible
}


// propagate the toggled location of a treeitem down to the 'baseURL' property
function ToggleLocation(aoTreeItem)
{ // check visibility
  var oVisible1 = {}, oVisible2 = {};
  oVisible1[gksFlagHideJar]   = true;
  oVisible2[gksFlagNoIconLoc] = true;
  if (!TestFlags(aoTreeItem, oVisible1) && !TestFlags(aoTreeItem, oVisible2))
  { // visible!
    ToggleFlag(aoTreeItem, gksFlagUserCSS, gksFlagHideLoc);
    var oItem = GetBaseURLTreeItem(aoTreeItem);
    if (oItem)
    { // get the value column cell
      var   sBaseURL = GetFlags(oItem)[gksFlagValue];
      const koLocJar = ChromeURI2Info(sBaseURL);
      sBaseURL = ChromeInfo2URI(sBaseURL, !koLocJar.isProfile, koLocJar.isJar);
      // update tree
      var oFlags = {};
      oFlags[gksFlagValue] = sBaseURL;
      AddChromeTreeItemStyles(oItem, oFlags)
    }
    else
    { // no 'baseURL'
      dump("Mnenhy::no property 'baseURL' for "+aoTreeItem.getAttribute(gksAttrID)+"\n")
    }
  } // visible
}


// propagate the toggled state of a treeitem down to the 'disabled' property
function ToggleState(aoTreeItem)
{ // check visibility
  var oVisible = {};
  oVisible[gksFlagHideState] = true;
  if (!TestFlags(aoTreeItem, oVisible))
  { // visible!
    ToggleFlag(aoTreeItem, gksFlagDisCSS,  gksFlagHideState);
    // the disabled attribute is *always* set in the profile chrome.rdf
    var oItem = GetBaseURLTreeItem(aoTreeItem, gksFlagDisRDF, false);
    if (!oItem)
    { // create default item
      const koCont     = aoTreeItem.lastChild.firstChild.lastChild;
      var   rsID       = aoTreeItem.getAttribute(gksAttrID).split(gksBaseSplitter).slice(2);
      const koValue    = {tag: false, val: false};
      const koUserData = {URN:                 rsID,
                          TreeCont:            koCont,
                          oLoopOverProperties: {}};
      ProcessProp(gksFlagDisRDF, koValue, koUserData);
      oItem = koCont.lastChild;
    }

    if (oItem)
    { // get the value column cell
      var sDisabled = GetFlags(oItem)[gksFlagValue];
      // toggle the value
      var bDisabled = (sDisabled != gksFlagDisTest);
      // update tree
      var oFlags = {};
      oFlags[gksFlagValue] = String(bDisabled);
      AddChromeTreeItemStyles(oItem, oFlags)
    }
    else
    { // no 'disabled'
      dump("Mnenhy::no property 'disabled' for "+aoTreeItem.getAttribute(gksAttrID)+"\n")
    }
  } // visible
}


// create name/value flag object
// hide status, location, and jar column, if abHide is |true|
function CreateFlags(asName, asValue, abHide)
{
  var oFlags = {};
  // show just Package and Value columns
  if (abHide)
  {
    oFlags[gksFlagHideState] = true;
    oFlags[gksFlagHideLoc  ] = true;
    oFlags[gksFlagHideJar  ] = true;
  }
  if (asName)
    oFlags[gksFlagLabel] = asName;
  if (asValue)
    oFlags[gksFlagValue] = asValue;
  return oFlags;
}


// test the 'flags' attribute of the given treeitem for the existence of the given flags
// return |true| if all exist
// if abBackup is |true|, backup has priority
function TestFlags(aoTreeItem, aoFlags, abBackup)
{
  if (!aoFlags)
    aoFlags = {};
  var oFlags = null;
  if (abBackup)
  { // check backup flags
    const ksFlagsBak = GetFlags(aoTreeItem, true, true);
    if (ksFlagsBak)
      oFlags = GetFlags(aoTreeItem, false, true);
  }
  if (!oFlags)
  { // no backup, get current
    oFlags = GetFlags(aoTreeItem);
  }
  for (var sFlag in aoFlags)
    if (!(sFlag in oFlags))
      return false; // flag not found
  return true;      // all flags found
}


// get the flags of aoTreeItem
// if abString is |true|, return flags as string
// else return the flags object
// if abBackup is |true|, read the backupped flags
function GetFlags(aoTreeItem, abString, abBackup)
{
  const ksFlags = aoTreeItem.getAttribute(gksAttrFlags + (abBackup ? gksAttrOldSuffix : ""));
  if (abString)
    return ksFlags;
  return GetFlagsObj(ksFlags);
}
// convert flags string to object
function GetFlagsObj(asFlags)
{
  return eval(asFlags) || {};
}


// is this treeitem dirty, i.e. does it have changed flags?
function IsFlagsDirty(aoTreeItem)
{
  return aoTreeItem.hasAttribute(gksAttrFlagsOld);
}


// return all flags that are contained either in aoFlags0 or aoFlags1, but not in both
// if abTest is |true|, return also Flags with different values (returns value from aoFlags0 then)
function DifferFlags(aoFlags0, aoFlags1, abTest)
{ // clone flags
  var oFlags0 = eval(aoFlags0.toSource());
  var oFlags1 = eval(aoFlags1.toSource());
  var sFlag;
  for (sFlag in oFlags0)
  { // process first flag set
    if (sFlag in oFlags1)
    { // found in both
      if (!abTest || oFlags0[sFlag] == oFlags1[sFlag])
      { // delete it
        delete oFlags0[sFlag];
        delete oFlags1[sFlag];
      }
    }
  }
  for (sFlag in oFlags1)
  { // process second flag set
    // all remaining flags here are not in oFlags0, so we must copy them
    oFlags0[sFlag] = oFlags1[sFlag];
  }
  return oFlags0;
}


// set the properties attribute for all the aoTreeItem's treecells
// aoFlags contains the respective flags as names of the elements of an associative array *object*
// (the value can transport flag specific values)
//
// we have five columns to style:
// Package              Value     Status        Location        Jar
// [dirty flag]<name>   <value>   [x]active     [#]application  [#]{jar}
// []<name>             <value>   [.]inactive   [.]profile      [.]{local}
//
// if <name>(gksFlagLabel) or <value>(gksFlagValue) are given, they will be set,
// otherwise the current label attribute value won't be touched
// all other texts will always be set here
//
// column dependend styles can be hidden by the following flags
// gksFlagHidePack      -     gksFlagHideState  gksFlagHideLoc  gksFlagHideJar
// the visibility of icons is always overruled by GodMode, ie. some icons are hidden then
//
// the dirty flag is computed here
// if abIgnoreDirty is set to |true|, the aoFlags will be set as current data
// and the backup data will be lost
function SetChromeTreeItemStyles(aoTreeItem, aoFlags, abIgnoreDirty)
{ // store flags, backup if changed, compute dirty flag
  // outside of this function, bDirty is symbolized by the existence of the gksAttrFlagsOld attribute
  var bDirty = false;
  const ksFlags    = aoFlags.toSource();                        // new flags
  const ksFlagsCur = aoTreeItem.getAttribute(gksAttrFlags);     // current flags
  const ksFlagsBak = aoTreeItem.getAttribute(gksAttrFlagsOld);  // old flags
  if (ksFlagsBak)
  { // have old data, so current data is irrelevant - just set new data
    aoTreeItem.setAttribute(gksAttrFlags, ksFlags);
    // compare new data with old data
    const koFlagsBak = GetFlagsObj(ksFlagsBak);    // old flags
    bDirty = !goMnenhy.IsEqual(aoFlags, koFlagsBak);
    if (!bDirty)
      aoTreeItem.removeAttribute(gksAttrFlagsOld); // new is current is old
  }
  else
  { // have no old data, so backup the current data before setting any new data
    // compare new data with current data
    if (ksFlagsCur)
    { // we have been here before
      const koFlagsCur = GetFlagsObj(ksFlagsCur);    // current flags
      bDirty = !goMnenhy.IsEqual(aoFlags, koFlagsCur);
      if (bDirty)
      { // backup current and set new
        aoTreeItem.setAttribute(gksAttrFlagsOld, ksFlagsCur);
      }
    }
    aoTreeItem.setAttribute(gksAttrFlags, ksFlags);
  }
  if (abIgnoreDirty)
  { // ignore backup data
    bDirty = false;
    aoTreeItem.removeAttribute(gksAttrFlagsOld);
  }

  // compute the common text styles
  var rTextProps = [gksFlagPropBase];   // common text styles
  if (gksFlagDisCSS in aoFlags)         // * status:
    rTextProps.push(gksFlagDisCSS);     //   - inactive
  if (gksFlagDelCSS in aoFlags)
    rTextProps.push(gksFlagDelCSS);     //   - deleted
  if (gksFlagUserCSS in aoFlags)        // * location:
    rTextProps.push(gksFlagUserCSS);    //   - profile
  if (gksFlagJarCSS in aoFlags)         // * jar:
    rTextProps.push(gksFlagJarCSS);     //   - local
  if (bDirty)
    rTextProps.push(gksFlagDirty);      //   - local

  // get the treecells
  const koCells = aoTreeItem.firstChild.childNodes;

  // compute styles depending on column
  var i;
  var rProps = [];
  for (i = 0; i <= gkColJar; ++i)
    rProps[i] = rTextProps.slice();

  // package column
  if (gksFlagHidePack in aoFlags)
  { // hide name
    koCells[gkColPack].setAttribute(gksAttrLabel, "")
  }
  else
  { // set name (if given)
    if (gksFlagLabel in aoFlags)
    {
      koCells[gkColPack].setAttribute(gksAttrLabel, aoFlags[gksFlagLabel])
    }
    // show dirty flag
    if (bDirty)
    {
      rProps[gkColPack].push(gksFlagBase);
      rProps[gkColPack].push(gksFlagYes);
    }
  }

  // value column
  if (gksFlagValue in aoFlags)
  { // set value (if given)
    koCells[gkColValue].setAttribute(gksAttrLabel, aoFlags[gksFlagValue])
    // due to bug 158344 the following two lines are currently pretty useless :(
    if (!aoFlags[gksFlagValue].search(goChroManRDF.app.CreateURN()))
      rProps [gkColValue].push(gksFlagValueCSS);  // show URNs as link (hand cursor)
  }
  else
  {
    koCells[gkColValue].setAttribute(gksAttrLabel, "")
  }

  // status column
  if (gksFlagHideState in aoFlags)
  { // hide state
    koCells[gkColState].setAttribute(gksAttrLabel, "");
  }
  else
  { // show state
    // the checkmark must only be shown if in GodMode or if location is profile
    const kbShowIconState = goMnenhy.uninstall.mbIsGodMode || (gksFlagUserCSS in aoFlags);
    if (kbShowIconState)
      rProps[gkColState].push(gksCheckmarkBase);
    var sh;
    if (gksFlagDisCSS in aoFlags)
    {
      sh = gksStateInactive;
    }
    else
    {
      rProps [gkColState].push(gksCheckmarkYes);
      sh = gksStateActive;
    }
    if (gksFlagDelCSS in aoFlags)
      sh = gksStateDeleted;
    koCells[gkColState].setAttribute(gksAttrLabel, sh);
  }

  // location column
  if (gksFlagHideLoc in aoFlags)
  { // hide location
    koCells[gkColLoc].setAttribute(gksAttrLabel, "");
  }
  else
  { // show location
    // the checkmark must only be shown in GodMode
    const kbShowIconLoc = goMnenhy.uninstall.mbIsGodMode && !(gksFlagNoIconLoc in aoFlags);
    if (kbShowIconLoc)
      rProps[gkColLoc].push(gksDiamondBase);
    if (gksFlagUserCSS in aoFlags)
    {
      koCells[gkColLoc].setAttribute(gksAttrLabel, gksLocationUser);
    }
    else
    {
      if (kbShowIconLoc)
        rProps [gkColLoc].push(gksDiamondYes);
      koCells[gkColLoc].setAttribute(gksAttrLabel, gksLocationApp);
    }
  }

  // jar column
  // the diamond must only be shown if in GodMode or if location is profile
  const kbShowIconJar = goMnenhy.uninstall.mbIsGodMode || (gksFlagUserCSS in aoFlags);
  if (kbShowIconJar && !(gksFlagHideJar in aoFlags))
  {
    rProps[gkColJar].push(gksDiamondBase);
    if (!(gksFlagJarCSS in aoFlags))
      rProps[gkColJar].push(gksDiamondYes);
  }

  // set the properties on the treeitem's cells
  for (i = 0; i < rProps.length; ++i)
    aoTreeItem.firstChild.childNodes[i].setAttribute(gksAttrProp, rProps[i].join(" "));
}


// like above, but add flags to current flags
function AddChromeTreeItemStyles(aoTreeItem, aoFlags, abIgnoreDirty)
{ // get current flags
  var oFlags = GetFlags(aoTreeItem);
  for (var sFlag in aoFlags)
    oFlags[sFlag] = aoFlags[sFlag];
  SetChromeTreeItemStyles(aoTreeItem, oFlags, abIgnoreDirty);
}


// set various properties of treeitem incl. cell labels
// only non-null items will be set
function EditChromeTreeItem(aoTreeItem, abIsCont, aoFlags)
{
  if (abIsCont !== null)
    aoTreeItem.setAttribute(gksAttrCont, abIsCont);
  var oRow = aoTreeItem.firstChild;
  SetChromeTreeItemStyles(aoTreeItem, aoFlags)
}


// create a <treeitem> for the Chrome Manager main tree and return it
// if abIsCont is |true|, the last child of the <treeitem> will be <treechildren>
function CreateChromeTreeItem(asID, abIsCont, aoFlags)
{
  // create DOM elements
  var oItem = document.createElement(gksTreeItem);
  oItem.setAttribute(gksAttrID, asID);
  var oRow = document.createElement(gksTreeRow);
  oRow.appendChild(document.createElement(gksTreeCell));
  oRow.appendChild(document.createElement(gksTreeCell));
  oRow.appendChild(document.createElement(gksTreeCell));
  oRow.appendChild(document.createElement(gksTreeCell));
  oRow.appendChild(document.createElement(gksTreeCell));
  oItem.appendChild(oRow);
  if (abIsCont)
    oItem.appendChild(document.createElement(gksTreeCont));

  // set values
  EditChromeTreeItem(oItem, abIsCont, aoFlags);
  return oItem;
}


// check if an element with id=asID is already in childNodes of aoItem
function ContainsChild(aoItem, asID)
{
  const ko = aoItem.childNodes;
  const ki = ko.length;
  for (var i = 0; i < ki; ++i)
    if (ko[i].id == asID)
      return true;
  return false;
}


// |
// |  loop functions
// |

// get the RDF sequence arSeqName of both app and user chrome.rdf
// and call afCallback(element name, is-app-element, user data)
function LoopOverRDFSeq(arSeqName, afCallback, aoUserData)
{
  const ksSeqName = goChroManRDF.app.CreateURN(arSeqName, true);
  var rbSeq = {};
  // to avoid name clashes, we prepend the indices with 0 and 1
  goChroManRDF.app. GetNodeList(ksSeqName, true, null, null, rbSeq, "1", true);
  goChroManRDF.user.GetNodeList(ksSeqName, true, null, null, rbSeq, "0", false);

  var iCount = 0;
  var rCheck = {};
  for (var sSeq in rbSeq)
  { // strip the prefix when calling callback back ;-)
    const ksBaseName = sSeq.substr(1);
    afCallback(ksBaseName, rbSeq[sSeq], aoUserData);
    // count every base name only once
    if (!(ksBaseName in rCheck))
    {
      rCheck[ksBaseName] = true;
      ++iCount;
    }
  }
  return iCount;
}


// prepare a property arc for usage with LoopOverProperties
function PreparePropertyArc(aoResourceIgnored, aoArc, aoTarget, aoUserData)
{
  if ((aoArc instanceof goMnenhy.rdf.gkIRDFResource) && (aoTarget instanceof goMnenhy.rdf.gkIRDFNode))
  {  // we currently only know about nsIResources and nsILiterals
    if ((aoTarget instanceof goMnenhy.rdf.gkIRDFResource) || (aoTarget instanceof goMnenhy.rdf.gkIRDFLiteral))
    {
      const ksIndex = aoUserData.sPrefix + aoArc.Value;
      aoUserData.rArcs[ksIndex] = {val: aoTarget.Value, tag: aoUserData.oTag};
    }
  }
  return true;  // continue!
}


// get all arcs *from* element with URN arElement, from both app and user chrome.rdf
// (aka the "properties" of the element)
// and call afCallback(property name, property value, user data)
function LoopOverProperties(arElement, afCallback, aoUserData)
{
  const ksElement = goChroManRDF.app.CreateURN(arElement, true)
  var oProperties = {};
  // to avoid name clashes, we prepend the indices with 0 and 1
  var oArcUserData = {rArcs:oProperties, sPrefix:"1", oTag:true};
  goChroManRDF.app .GetAllArcsOut(goChroManRDF.app .GetNodeRes(ksElement), PreparePropertyArc, oArcUserData);
  oArcUserData = {rArcs:oProperties, sPrefix:"0", oTag:false};
  goChroManRDF.user.GetAllArcsOut(goChroManRDF.user.GetNodeRes(ksElement), PreparePropertyArc, oArcUserData);
  aoUserData.oLoopOverProperties = {};
  var iCount = 0;
  for (var sProp in oProperties)
  { // strip the prefix when calling callback back ;-)
    afCallback(sProp.substr(1), oProperties[sProp], aoUserData);
    ++iCount;
  }
  return {oFlags: aoUserData.oLoopOverProperties, iCount: iCount};
}


// get all arcs pointing *to* element with URN arElement via the "package" property,
// from both app and user chrome.rdf (aka "linking" to the element)
// and call afCallback(linking element resource, user data)
function LoopOverLinks(arElement, afCallback, aoUserData)
{
  const ksElement = goChroManRDF.app.CreateURN(arElement, true);
  const kroLinks = [goChroManRDF.app .GetSourcesForNode(gksPropPack, ksElement),
                    goChroManRDF.user.GetSourcesForNode(gksPropPack, ksElement)];
  var oLinks = new goMnenhy.CEnumList(kroLinks);

  var iCount = 0;
  while (oLinks.hasMoreElements())
  {
    afCallback(oLinks.getNext(), aoUserData);
    ++iCount;
  }
  return iCount;
}



// |
// |  loop process functions
// |

// |  commons

// process a property
function ProcessProp(asProp, aoValue, aoUserData)
{
  var sProp    = asProp.replace(gkxMozillaNS, "");      // strip off the leading namespace
  var rPropURN = aoUserData.URN.slice();                // clone element URN
  rPropURN.push(aoValue.tag + gksAttrDivider + sProp);  // add location and property
  const ksPropURN = goChroManRDF.app.CreateURN(rPropURN);
  if (!ContainsChild(aoUserData.TreeCont, ksPropURN))
  { // don't add property twice
    var oItem = CreateChromeTreeItem(ksPropURN,
                                     false,
                                     CreateFlags(sProp, String(aoValue.val)));
    aoUserData.TreeCont.appendChild(oItem);

    // test some flags
    switch (sProp)
    {
      case gksFlagDisRDF:
        if (aoValue.val == gksFlagDisTest)
          aoUserData.oLoopOverProperties[gksFlagDisCSS] = true;
        break;

      case gksFlagUserRDF:
        if (aoValue.val == gksFlagUserTest)
          aoUserData.oLoopOverProperties[gksFlagUserCSS] = true;
        break;

      case gksFlagJarRDF:
        if (aoValue.val.search(gkxFlagJarTest))
          aoUserData.oLoopOverProperties[gksFlagJarCSS] = true;
        // skin/locale packages do not have gksFlagUserRDF,
        // so we assume that the baseURL's position is the same
        if (("bSkinLoc" in aoUserData) && (!aoValue.tag))
          aoUserData.oLoopOverProperties[gksFlagUserCSS] = true;
        break;
    }

    // set property treeitem styles
    var oPropStyles = {};
    oPropStyles[gksFlagHideJar]   = true;
    oPropStyles[gksFlagHideState] = true;
    oPropStyles[gksFlagNoIconLoc] = true;
    if (!aoValue.tag)
      oPropStyles[gksFlagUserCSS] = true;
    AddChromeTreeItemStyles(oItem, oPropStyles, true);
  }
}


// |  package

// process the elements linking to the package
function ProcessPackLinks(aoLink, aoUserData)
{
  // we're only interested in resources
  if (aoLink instanceof Components.interfaces.nsIRDFResource)
  {
    var rsGroupComplete = aoLink.Value.split(gksBaseSplitter);
    var sGroup = rsGroupComplete[2];
    switch (sGroup)
    {
      case gksBaseSkin:
      case gksBaseLoc:
        { // create the group title item
          const ksName = rsGroupComplete[3];
          var rLinkURN = aoUserData.URN[sGroup].slice(); // clone URN
          rLinkURN.push(ksName);
          var oGroupItem = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rLinkURN),
                                                false,
                                                CreateFlags(ksName, aoLink.Value, true));
          aoUserData.TreeCont[sGroup].appendChild(oGroupItem);
        }
        break;
    } // switch
  } // is resource
}


// process a package entry in the chrome.rdf:
// - display its properties
// - display its skins
// - display its locales
function ProcessPackage(asPack, abIsAppPack, aoUserData)
{
  var    rPackURN = asPack.split(gksBaseSplitter).slice(2);           // clone "Packages" URN
  const ksPackURN = goChroManRDF.app.CreateURN(rPackURN);
  if (!ContainsChild(aoUserData.TreeCont, ksPackURN))
  { // don't add package twice
    var oPackItem = CreateChromeTreeItem(ksPackURN, true, CreateFlags(rPackURN.slice(-1).pop()));
    aoUserData.TreeCont.appendChild(oPackItem);

    // +-
    // |  display the package's properties
    var rPropURN = rPackURN.slice(); // clone package URN
    rPropURN.push(gksBaseProp);      // add "property"
    var oPackItemProp = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rPropURN),
                                             true,
                                             CreateFlags(gksPropLabel, null, true));
    var oUserDataProp = {URN:      rPackURN,
                         TreeCont: oPackItemProp.lastChild};
    const koPropValue = LoopOverProperties(rPackURN,
                                           ProcessProp,
                                           oUserDataProp);
    // don't show twisty for empty properties, set some gathered flags
    if (koPropValue.iCount)
      AddChromeTreeItemStyles(oPackItem, koPropValue.oFlags, true);
    else
      oPackItemProp.removeAttribute(gksAttrCont);
    oPackItem.lastChild.appendChild(oPackItemProp);

    // +-
    // |  display the package's skins and locales
    var rSkinURN = rPackURN.slice(); // clone package URN
    rSkinURN.push(gksBaseSkin);      // add "skin"
    var rLocURN  = rPackURN.slice(); // clone package URN
    rLocURN. push(gksBaseLoc);       // add "locales"
    var oPackItemSkin = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rSkinURN),
                                             true,
                                             CreateFlags(gksSkinLabel, null, true));
    var oPackItemLoc  = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rLocURN),
                                             true,
                                             CreateFlags(gksLocLabel,  null, true));
    var oUserDataLinks = {URN:      [],
                          TreeCont: []};
    oUserDataLinks.URN     [gksBaseSkin] = rSkinURN;
    oUserDataLinks.URN     [gksBaseLoc]  = rLocURN;
    oUserDataLinks.TreeCont[gksBaseSkin] = oPackItemSkin.lastChild;
    oUserDataLinks.TreeCont[gksBaseLoc]  = oPackItemLoc .lastChild;

    LoopOverLinks(rPackURN,
                  ProcessPackLinks,
                  oUserDataLinks);

    // don't show twisty for empty skins
    if (!oPackItemSkin.lastChild.childNodes.length)
      oPackItemSkin.removeAttribute(gksAttrCont);
    oPackItem.lastChild.appendChild(oPackItemSkin);
    // don't show twisty for empty locales
    if (!oPackItemLoc.lastChild.childNodes.length)
      oPackItemLoc.removeAttribute(gksAttrCont);
    oPackItem.lastChild.appendChild(oPackItemLoc);
  }
}


// |  skin & locale

// process a skin's or locale's packages
function ProcessSkinLocPack(asPack, abIsAppPack, aoUserData)
{
  var rPackURN  = asPack.split(gksBaseSplitter).slice(2); // clone skin/locale URN
  var oPackItem = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rPackURN),
                                       true,
                                       CreateFlags(rPackURN.slice(-1).pop()));
  aoUserData.TreeCont.appendChild(oPackItem);

  // +-
  // |  display the package's properties
  var rPropURN = rPackURN.slice(); // clone package URN
  rPropURN.push(gksBaseProp);      // add "property"
  var oPackItemProp = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rPropURN),
                                           true,
                                           CreateFlags(gksPropLabel, null, true));
  var oUserDataProp = {URN:      rPackURN,
                       TreeCont: oPackItemProp.lastChild,
                       bSkinLoc: true};
  const koPropValue = LoopOverProperties(rPackURN,
                                         ProcessProp,
                                         oUserDataProp);
  // don't show status; sort; don't show twisty for empty properties; set some gathered flags
  koPropValue.oFlags[gksFlagHideState] = true;
  if (koPropValue.iCount)
    AddChromeTreeItemStyles(oPackItem, koPropValue.oFlags, true);
  else
    oPackItemProp.removeAttribute(gksAttrCont);
  oPackItem.lastChild.appendChild(oPackItemProp);
}


// process a skin or locale entry in the chrome.rdf:
// - display its properties
// - display its packages
function ProcessSkinLoc(asSkinLoc, abIsAppIgnored, aoUserData)
{
  var rSkinLocURN = asSkinLoc.split(gksBaseSplitter).slice(2); // clone "Packages" URN
  if (!ContainsChild(aoUserData.TreeCont, asSkinLoc))
  { // don't add skin/locale twice
    var oItem = CreateChromeTreeItem(asSkinLoc,
                                     true,
                                     CreateFlags(rSkinLocURN.slice(-1).pop(), null, true));
    // +-
    // |  display the skin's or locale's properties
    var rPropURN = rSkinLocURN.slice(); // clone package URN
    rPropURN.push(gksBaseProp);         // add "property"

    var oItemProp = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rPropURN),
                                         true,
                                         CreateFlags(gksPropLabel, null, true));
    var oUserDataProp = {URN:      rSkinLocURN,
                         TreeCont: oItemProp.lastChild};
    const koPropValue = LoopOverProperties(rSkinLocURN,
                                           ProcessProp,
                                           oUserDataProp);
    // don't show twisty for empty properties
    if (!koPropValue.iCount)
      oItemProp.removeAttribute(gksAttrCont);
    oItem.lastChild.appendChild(oItemProp);

    // +-
    // |  display the skin's or locale's packages
    var rPackURN = rSkinLocURN.slice(); // clone package URN
    rPackURN.push(gksBasePacks);        // add "packages"
    var oItemPack = CreateChromeTreeItem(goChroManRDF.app.CreateURN(rPackURN),
                                         true,
                                         CreateFlags(gksPackLabel, null, true));
    var oUserDataPack = {URN:      rSkinLocURN,
                         TreeCont: oItemPack.lastChild};
    const kiPackCount = LoopOverRDFSeq(rPackURN,
                                       ProcessSkinLocPack,
                                       oUserDataPack);
    // don't show twisty if there are no packages
    if (kiPackCount)
    { // sort
      const koChildren = new gfSort(oUserDataPack.TreeCont, gksAttrID, true);
      goMnenhy.QuickSort(koChildren, 0, kiPackCount - 1, true);
    }
    else
      oItemPack.removeAttribute(gksAttrCont);

    oItem.lastChild.appendChild(oItemPack);
    aoUserData.TreeCont.appendChild(oItem);
  }
}


// create one main level item of the ChroManTree
function CreateMainTreeItem(arBaseURN, asLabel, afCallback)
{
  debugdump("CreateMainTreeItem("+arBaseURN+", "+asLabel+", "+afCallback.name+")+\n")
  var rSeqURN   = arBaseURN.slice(); // clone URN
  rSeqURN.push(gksBaseRoot);         // add "root"
  var oTreeItem = CreateChromeTreeItem(goChroManRDF.app.CreateURN(arBaseURN),
                                       true,
                                       CreateFlags(asLabel, null, true));
  var oUserData = {URN:      arBaseURN,
                   TreeCont: oTreeItem.lastChild};
  var iCount    = LoopOverRDFSeq(rSeqURN,
                                 afCallback,
                                 oUserData);
  // sort; don't show twisty on empty item
  if (iCount)
  { // copy the sort object into our document context
    const koChildren = new gfSort(oUserData.TreeCont, gksAttrID, true);
    goMnenhy.QuickSort(koChildren, 0, iCount - 1, true);
  }
  else
    oTreeItem.removeAttribute(gksAttrCont);
  goChroManCont.appendChild(oTreeItem);
  debugdump("CreateMainTreeItem-\n")
}


// debug
function debugdump(aoDump)
{
  if (this.gbChroManDebugDump)
    dump(aoDump);
}


// read both chrome.rdf and build the ChroManTree
//
// Structure of the chrome.rdf
//
// xmlns:c="http://www.mozilla.org/rdf/chrome#"
//
//  +- urn:mozilla:package:root
//  |  +- urn:mozilla:package:mnenhy  <-----------------------<-+
//  |  |  +- c:name                                             |
//  |  |  +- c:baseURL                                          |
//  |  |  +- c:disabled                 (and other properties)  |
//  |  .  .  ...                                                |
//  +- urn:mozilla:skin:root                                    |
//  |  +- urn:mozilla:skin:classic/1.0                          .
//  |  |  +- c:description                                      ^
//  |  |  +- c:locType                  (and other  properties) |
//  |  |  .  ...                                                |
//  |  |  +- urn:mozilla:skin:classic/1.0:packages              |
//  |  |  |  +- urn:mozilla:skin:classic/1.0:mnenhy             |
//  |  |  |  |  +- c:skinVersion                                |
//  |  |  |  |  +- c:allowScripts       (and other properties)  |
//  |  |  |  |  +- c:baseURL                                    |
//  |  |  |  |  +- c:package          >----------------------->-+
//  |  .  .  .  .  ...                                          |
//  +- urn:mozilla:locale:root                                  |
//     +- urn:mozilla:locale:de-DE                              |
//     |  +- c:locType   (and maybe more)                       .
//     |  |  ...                                                ^
//     |  +- urn:mozilla:locale:de-DE:packages                  |
//     |  |  +- urn:mozilla:locale:de-DE:mnenhy                 |
//     |  |  |  +- c:baseURL                                    |
//     |  |  |  +- c:package          >----------------------->-+
//     .  .  .  .  ...
//
function InitChroManTree()
{
  goMnenhy.SetWaitCursor(window);
  // init debug
  this.gbChroManDebugDump = goMnenhy.GetPref(gksChroManDebugPref, "bool");
  // get the sort ctor into the context of this window
  eval("gfSort="+goMnenhy.CSort.toSource());
  // init the tree pointer and popup
  goChroManTree = document.getElementById(gksChroManTree);
  goChroManCont = document.getElementById(gksChroManCont);
  goChroManPopup =  {act  : document.getElementById("mnenhyPopupAct"  ),
                     deact: document.getElementById("mnenhyPopupDeact"),
                     prof : document.getElementById("mnenhyPopupProf" ),
                     app  : document.getElementById("mnenhyPopupApp"  ),
                     enjar: document.getElementById("mnenhyPopupEnjar"),
                     dejar: document.getElementById("mnenhyPopupDejar") };
  // init key/button broadcasters
  for (var sBC in gkrsBaseBC)
    SetBroadcasterValue(gkrsBaseBC[sBC], false);
  if (goMnenhy.uninstall.mbIsGodMode)
  {
    SetBroadcasterValue(gkrsBaseBC.ksBCGodMode, true);
    window.title = gksRootTitle;
  }
  // init the chrome.rdf files
  goChroManRDF = {app: goMnenhy.uninstall.GetChromeRDF(false), user: goMnenhy.uninstall.GetChromeRDF(true)};
  // remove the "Loading..." message
  while (goChroManCont.lastChild)
    goChroManCont.removeChild(goChroManCont.lastChild);

  // |
  // | create "packages" tree item
  // |
  CreateMainTreeItem([gksBasePack], gksPackLabel, ProcessPackage);

  // |
  // | create "Skins" tree item
  // |
  CreateMainTreeItem([gksBaseSkin], gksSkinLabel, ProcessSkinLoc);

  // |
  // | create "Locales" tree item
  // |
  CreateMainTreeItem([gksBaseLoc],  gksLocLabel,  ProcessSkinLoc);

  goMnenhy.UnsetWaitCursor(window);
}


// accept only changed packages
function DirtyTreeCellFilter(aoNode)
{
  if ((aoNode.nodeName == gksTreeItem) && (aoNode.id.search(gksAttrDivider) < 0) && (IsFlagsDirty(aoNode)))
      return NodeFilter.FILTER_ACCEPT;
  return NodeFilter.FILTER_SKIP;
};


// walk down the ChroManTree and update the chrome registry accordingly
function ExitChroManTree()
{ // walk down the tree
  goMnenhy.SetWaitCursor(window);
  const koTreeWalker = document.createTreeWalker(goChroManCont,
                                                 NodeFilter.SHOW_ELEMENT,
                                                 DirtyTreeCellFilter,
                                                 true);
  if (koTreeWalker)
  { // process all relevant packages
    var oNextNode = koTreeWalker.nextNode();
    goMnenhy.UnsetWaitCursor(window);
    if (oNextNode)
    { // have changes
      if (goMnenhy.Confirm(gksExitDialogOK, null, this))
      { // we are allowed to make the changes
        goMnenhy.SetWaitCursor(window);
        const koUI = goMnenhy.uninstall;
        const koCR = goMnenhy.m_koChromeRegService;
        // backup both chrome.rdf files and the installed-chrome.txt
        koUI.BackupChromeRegistry();
        // walk the tree and write the rdf and installed-chrome changes
        // collect files for deletion (as URIs)
        var oDeletableFiles = {};
        for (; oNextNode; oNextNode = koTreeWalker.nextNode())
        {
          // get the changed flags
          const koFlags        = GetFlags(oNextNode);
          const koFlagsOld     = GetFlags(oNextNode, false, true);
          const koChangedFlags = DifferFlags(koFlags, koFlagsOld, true);

          // get the package urn array
          // and provide the package data for moving and deleting
          const krsPackage = oNextNode.id.split(gksBaseSplitter);
          debugdump("Mnenhy::ExitChroManTree: package urn="+oNextNode.id+"\n")
          var sPackageType = "";
          var rPackage     = [[]];
          var sPackage     = krsPackage[3];
          if ((gksFlagDelCSS in koChangedFlags) || (gksFlagUserCSS in koChangedFlags))
          {
            switch (krsPackage[2])
            {
              case koUI.gksURNBasePack: sPackageType = koUI.gksTypeContent; break;
              case koUI.gksURNBaseSkin: sPackageType = koUI.gksTypeSkin;    break;
              case koUI.gksURNBaseLoc : sPackageType = koUI.gksTypeLocale;  break;
            }
            rPackage[0].push(sPackage, sPackageType);
          }

          // if the package will be deleted, we don't care for other flags
          if (gksFlagDelCSS in koChangedFlags)
          { // delete the package
            koUI.UninstallPackages(rPackage, oDeletableFiles);
          }
          else
          { // 1. move package from profile to application or vice versa
            // 2. enjar/dejar a package
            // 3. (de)activate a package

            // (1) move
            if (gksFlagUserCSS in koChangedFlags)
            { // move package from profile to application or vice versa
              // subpackages will not be moved!
              debugdump("Mnenhy::ExitChroManTree(1): moving package\n")
              const kbNewIsProfile = (gksFlagUserCSS in koFlags);
              // remember files that may be deleted afterwards
              // if we have a jar, just copy it
              // if we have a directory, copy it and try to copy a respective jar also
              const koJARItem   = GetBaseURLTreeItem(oNextNode);
              const ksSourceURI = GetFlags(koJARItem, false, true)[gksFlagValue];
              const kobLocJar   = ChromeURI2Info(ksSourceURI);
              const ksTargetURI = ChromeInfo2URI(ksSourceURI, kbNewIsProfile, kobLocJar.isJar);
              debugdump("Mnenhy::ExitChroManTree(1): ksSourceURI="+ksSourceURI+"\n")
              debugdump("Mnenhy::ExitChroManTree(1): ksTargetURI="+ksTargetURI+"\n")
              const koSourceFile = koUI.ConvertURI2File(ksSourceURI);
              const koTargetFile = koUI.ConvertURI2File(ksTargetURI);
              if (koSourceFile && koSourceFile.exists() && koTargetFile && !koTargetFile.exists())
              {
                goMnenhy.CopyFile(koSourceFile.parent, koSourceFile.leafName,
                                  koTargetFile.parent, koTargetFile.leafName);
                debugdump("Mnenhy::ExitChroManTree(1): copied ksSourceURI -> ksTargetURI\n")
              }
              if (!kobLocJar.isJar)
              { // if there's a jar copy it, too
                const ksSourceJAR = ChromeInfo2URI(ksSourceURI, !kbNewIsProfile, true);
                const ksTargetJAR = ChromeInfo2URI(ksSourceJAR, kbNewIsProfile, true);
                debugdump("Mnenhy::ExitChroManTree(1): ksSourceJAR="+ksSourceJAR+"\n")
                debugdump("Mnenhy::ExitChroManTree(1): ksTargetJAR="+ksTargetJAR+"\n")
                const koSourceJAR = koUI.ConvertURI2File(ksSourceJAR);
                const koTargetJAR = koUI.ConvertURI2File(ksTargetJAR);
                if (koSourceJAR && koSourceJAR.exists() && koTargetJAR && !koTargetJAR.exists())
                {
                  goMnenhy.CopyFile(koSourceJAR.parent, koSourceJAR.leafName,
                                    koTargetJAR.parent, koTargetJAR.leafName);
                  debugdump("Mnenhy::ExitChroManTree(1): copied ksSourceJAR -> ksTargetJAR\n")
                }
              }

              // remember selected skin and locale
              var sSelSkin = null;
              var sSelLoc  = null;

              // uninstall the old location
              var oRawURIs = {};
              if (krsPackage.length > 3)
              {
                if (krsPackage.length > 4)
                { // have skin or locale subpackage
                  debugdump("Mnenhy::ExitChroManTree(1): deinstall skin/locale subpackage\n")
                  // deinstall subpackage from both chrome.rdf
                  var sBaseURL;
                  var oPackageData = {oChromeRDF: null,
                                      sICText:    koUI.LoadInstalledChrome(),
                                      bIsProfile: false,
                                      oBaseURLs:  oRawURIs };
                  for (var iChrome = 0;
                       (iChrome < koUI.mroChromeRDF.length) && (koUI.mroChromeRDF[iChrome]);
                       ++iChrome)
                  { // init  uninstall data
                    oPackageData.oChromeRDF = koUI.mroChromeRDF[iChrome];
                    oPackageData.bIsProfile = !iChrome;
                    // get baseURL, delete installed-chrome.txt entry
                    const koSkinOrLocale = oPackageData.oChromeRDF.GetRes(oNextNode.id);
                    koUI.UninstallPackage(koSkinOrLocale, oPackageData);
                    // remove node
                    const krNode = krsPackage.slice(2);
                    oPackageData.oChromeRDF.RemoveNode(krNode);
                  }
                  koUI.SaveInstalledChrome(oPackageData.sICText);
                }
                else
                { // have content, locale or skin package
                  debugdump("Mnenhy::ExitChroManTree(1): deinstall content/locale/skin package\n")
                  if (krsPackage[2] == koUI.gksURNBasePack)
                  { // remember skin and locale for package
                    try
                    {
                      sSelSkin = koCR.getSelectedSkin(sPackage);
                    }
                    catch (oError)
                    { // non-critical error
                      dump("Mnenhy::ExitChroManTree(1): Can't read skin for package " + sPackage
                           + ":\n" + oError + "\n");
                    }
                    try
                    {
                      sSelLoc = koCR.getSelectedLocale(sPackage);
                    }
                    catch (oError)
                    { // non-critical error
                      dump("Mnenhy::ExitChroManTree(1): Can't read locale for package " + sPackage
                           + ":\n" + oError + "\n");
                    }
                  }
                  koUI.UninstallPackages(rPackage, oRawURIs);
                }
              }
              else
                dump("Mnenhy::ExitChroManTree(1): URN-Error!\n");

              // register the package from the new location
              // (since we're only here if we're in God Mode,
              //  we can do installed-chrome.txt magic here ;-) )
              // oRawURIs contains our package's source URI and the source URIs of all subpackages
              // We MUST NOT move the subpackage URIs, because that wasn't requested!
              var sICText = koUI.LoadInstalledChrome();
              for (var sRawURI in oRawURIs)
              { // "move" the URI
                const ksNewURI = (sRawURI == ksSourceURI) ? ksTargetURI : sRawURI;
                debugdump("Mnenhy::ExitChroManTree(1): * Re-registering "+sRawURI+" as "+ksNewURI+"\n");
                try
                {
                  const koChromeInfo = ChromeURI2Info(ksNewURI);
                  switch (koChromeInfo.sType)
                  {
                    case koUI.gksTypeContent:
                      koCR.installPackage(ksNewURI, koChromeInfo.isProfile);
                      break;
                    case koUI.gksTypeSkin:
                      koCR.installSkin   (ksNewURI, koChromeInfo.isProfile, false);
                      break;
                    case koUI.gksTypeLocale:
                      koCR.installLocale (ksNewURI, koChromeInfo.isProfile);
                      break;
                  }
                  // add magic
                  const ksLine = koUI.CreateICLine(ksNewURI, koChromeInfo.sType, koChromeInfo.isProfile);
                  sICText += ksLine;
                  // store as deletable
                  oDeletableFiles[sRawURI] = oRawURIs[sRawURI];
                }
                catch (oError)
                { // some install failed: alert it!
                  dump("Mnenhy::ExitChroManTree(1): Can't install provider with URI '" + ksNewURI
                       + "' for package " + sPackage + ":\n" + oError + "\n");
                }
              }
              koUI.SaveInstalledChrome(sICText);

              // reset skin and locale, if necessary
              if (sSelSkin)
              {
                try
                {
                  koCR.selectSkinForPackage(sSelSkin, sPackage, kbNewIsProfile);
                }
                catch (oError)
                { // usually non-critical error
                  dump("Mnenhy::ExitChroManTree(1): Can't set skin '" + sSelSkin
                       + "' for package " + sPackage + ":\n" + oError + "\n");
                }
              }
              if (sSelLoc)
              {
                try
                {
                  koCR.selectLocaleForPackage(sSelLoc, sPackage, kbNewIsProfile);
                }
                catch (oError)
                { // usually non-critical error
                  dump("Mnenhy::ExitChroManTree(1): Can't set locale '" + sSelLoc
                       + "' for package " + sPackage + ":\n" + oError + "\n");
                }
              }
            } // (1) move

            // (2) enjar/dejar
            if (gksFlagJarCSS in koChangedFlags)
            { // any moves have been made by now, so just enjar/dejar the package
              debugdump("Mnenhy::ExitChroManTree(2): enjarring/dejarring package\n")
              const koDejarTree = GetBaseURLTreeItem(oNextNode);
              const ksTarget    = GetFlags(koDejarTree)[gksFlagValue];
              const koURIInfo   = ChromeURI2Info(ksTarget);
              const ksSource    = ChromeInfo2URI(ksTarget,
                                                 koURIInfo.isProfile,
                                                 !koURIInfo.isJar);
              const koJarChrome = koUI.mroChromeRDF[koURIInfo.isProfile ? 0 : 1];
              const krsURN      = koDejarTree.id.split(gksBaseSplitter).slice(2, -1);
              var sICTextJar, sOldLine, sNewLine, iSize;

              if (gksFlagJarCSS in koFlags)
              { // dejar to local directory
                ExtractSinglePackage(ksSource, ksSource);
              }
              else
              { // remove the local directory
                oDeletableFiles[ksSource] = koURIInfo.isProfile;
              }

              // change chrome.rdf
              koJarChrome.ChangeItemValue(ksTarget, gksFlagJarRDF, krsURN);
              // change installed-chrome.txt
              if (koUI.mbIsGodMode)
              {
                sICTextJar = koUI.LoadInstalledChrome();
                iSize      = sICTextJar.length;
                sOldLine   = koUI.CreateICLine(ksSource, koURIInfo.sType, koURIInfo.isProfile, null, "\\s");
                sNewLine   = koUI.CreateICLine(ksTarget, koURIInfo.sType, koURIInfo.isProfile);
                // change it!
                sICTextJar = sICTextJar.replace(new RegExp(sOldLine), sNewLine);
                if (sICTextJar.length == iSize)
                  dump("Mnenhy::ExitChroManTree(2): Warning: couldn't find installed-chrome.txt line: " + sOldLine + "\n");
                else
                  koUI.SaveInstalledChrome(sICTextJar);
              } // update installed-chrome.txt
            } // (2) enjar/dejar


            // (3) (de)activate a package
            if (gksFlagDisCSS in koChangedFlags)
            { // (de)activate a package
              debugdump("Mnenhy::ExitChroManTree(3): (de)activating package\n")
              const kbSet     = (gksFlagDisCSS in koFlags);
              const ksPackage = krsPackage.slice(-1).pop();
              goMnenhy.m_koChromeRegService.setAllowOverlaysForPackage(ksPackage, !kbSet);
            } // (3) (de)activate a package

          } // process non-deleting flags
        } // loop over changed packages

        // clean-up
        koUI.PurgeChromeRegistry();
        // shutdown and file deletion
        koUI.ShutdownMozilla(oDeletableFiles, true);
        goMnenhy.UnsetWaitCursor(window);  // just in case the shutdown fails
        return true;  // changes made => close dialog
      } // have confirmation
      // have changes, but application denied => return to dialog
      return false;
    } // have changes
  } // have treewalker
  // no changes => close
  return true;
}


// ask before leaving
function CancelChroManTree()
{ // walk down the tree
  goMnenhy.SetWaitCursor(window);
  const koTreeWalker = document.createTreeWalker(goChroManCont,
                                                 NodeFilter.SHOW_ELEMENT,
                                                 DirtyTreeCellFilter,
                                                 true);
  if (koTreeWalker)
  { // process all relevant packages
    var oNextNode = koTreeWalker.nextNode();
    goMnenhy.UnsetWaitCursor(window);
    if (oNextNode)
    { // have changes
      return goMnenhy.Confirm(gksExitCancel, null, this);
    }
  }
  // close dialog
  return true;
}


// tree popup
function ShowChroManContext(aoEvent)
{ // get tree element - either from click or from current tree
  var oRow = {}, oColID = {}, oChildElt = {};
  goChroManTree.treeBoxObject.getCellAt(aoEvent.clientX, aoEvent.clientY, oRow, oColID, oChildElt);
  var oTreeItem = GetTreeItemAtRow(oRow.value);
  if (oTreeItem)
  { // reflect tree element status
    // status
    var oFlag = {};
    oFlag[gksFlagDisCSS] = true;  // inactive
    var bFlag = TestFlags(oTreeItem, oFlag);
    goChroManPopup.act  .hidden = !bFlag;
    goChroManPopup.deact.hidden =  bFlag;
    // location
    oFlag = {};
    oFlag[gksFlagUserCSS] = true; // profile
    bFlag = TestFlags(oTreeItem, oFlag);
    goChroManPopup.prof.hidden =  bFlag;
    goChroManPopup.app .hidden = !bFlag;
    // jar
    oFlag = {};
    oFlag[gksFlagJarCSS] = true;  // local
    bFlag = TestFlags(oTreeItem, oFlag);
    goChroManPopup.enjar.hidden = !bFlag;
    goChroManPopup.dejar.hidden =  bFlag;
    // show popup
    return true;
  }
  return false; // cancel the event
}
